
#include <string.h>
#include "w4ais.h"


/* Search for keywords, either normally or through ISINDEX.
** If there are only keywords in environment information, they are returned.
*/

char *getkeywords()
{
	static char value[MAXSTRLEN], tmpvalue[MAXSTRLEN];

	strcpy(value, getvalue(ISINDEXTXT, ""));
	if (!value[0]) {
		strcpy(value, getvalue(KEYWORDSTXT, ""));
		if (!value[0]) {
			if (!strchr(query_string, '&') &&
			!strchr(query_string, '=')) {
				strcpy(tmpvalue, decode(query_string));
				return tmpvalue;
			}
			else
				return "\0";
		}
	}
	strcpy(tmpvalue, decode(value));

	return tmpvalue;
}
