#include <string.h>
#include <stdlib.h>
#include "w4ais.h"

/* This gets a value for a certain variable from the environment,
** using PATH_INFO and POST and GET information. It returns a
** default if the variable is not found.
*/

char *getvalue(var, def)
	char *var;
	char *def;
{
	int i;
	char *c, *argp, argstr[MAXSTRLEN];
	static char value[MAXSTRLEN], tmpstr[MAXSTRLEN];

	if (query_string[0] == '\0' || !lstrstr(query_string, var)) {
		argp = (char *) getenv("PATH_INFO");
		if (argp == NULL || !lstrstr(argp, var)) {
			if (strlen(def) <= 1)
				return "\0";
			strcpy(tmpstr, decode(def));
			return tmpstr;
		}
		strcpy(argstr, argp);
	}
	else
		strcpy(argstr, query_string);

	for (i = 0, c = (char *) lstrstr(argstr, var) +
	strlen(var); *c && i < MAXSTRLEN && *c != '&'; c++)
		value[i++] = *c;
	value[i] = '\0';

	if (i) {
		strcpy(tmpstr, decode(value));
		return tmpstr;
	}

	if (strlen(def) <= 1)
		return "\0";
	strcpy(tmpstr, decode(def));
	return tmpstr;
}
