#include <stdio.h>
#include "w4ais.h"


/* Extract information within <title> tags, case insensitive,
** can be over multiple lines...
*/

#define TI_OPEN 1
#define TI_CLOSE 2
#define TI_FOUND 4

char *parsetitle(fp)
	FILE *fp;
{
	register int c;
	register char *p = '\0', *q;
	static char title[MAXTITLELEN];
	char tag[MAXTITLELEN];
	int lines, status;

	lines = status = 0;

	for (; lines < TITLETOPLINES ; ) {
		c = getc(fp);
		if (c == '\n')
			lines++;
		if (feof(fp))
			return title;
		switch(c) {
		case '<':
			tag[0] = c;
			status = TI_OPEN;
			for (q = tag + 1;; q++) {
				*q = getc(fp);
				if (*q == '>') {
					q++;
					break;
				}
			}
			*q = '\0';
			q = tag;
			if (lstrstr(q, "</title>")) {
				status = TI_CLOSE;
				*p = '\0';
				return title;
			}
			else {
				if (lstrstr(q, "<title>"))
					status = TI_FOUND;
			}
			break;
		default:
			if (status == TI_FOUND) {
				*p = c;
				p++;
			}
			else {
				if (status == TI_CLOSE)
					return title;
			}
		}
	}
	return title;
}
