
#include <stdio.h>
#include <string.h>
#include "w4ais.h"


/* The list that holds all the suffixes for checking against filenames.
*/

#define ICONVAR "$ICONURL"

struct suffixentry *addsuffix(sp, suffix, desc, url, mime)
	struct suffixentry *sp;
	char *suffix;
	char *desc;
	char *url;
	char *mime;
{
	struct suffixentry *tempnode, *newnode;

	newnode = (struct suffixentry *) emalloc(sizeof(struct suffixentry));
	newnode->suffix = (char *) mystrdup(suffix);
	newnode->desc = (char *) mystrdup(desc);
	newnode->url = (char *) mystrdup(replace(url, ICONVAR, iconurl));
	newnode->mime = (char *) mystrdup(mime);
	newnode->next = NULL;

	if (!strcmp(suffix, ".??")) {
		strcpy(unknown_icon, replace(url, ICONVAR, iconurl));
		strcpy(unknown_type, desc);
		strcpy(unknown_mime, mime);
	}

	if (sp == NULL)
		sp = newnode;
	else {
		for (tempnode = sp; tempnode->next != NULL; tempnode =
		tempnode->next)
			;
		tempnode->next = newnode;
	}

	return sp;
}
