
#include <string.h>
#include <stdlib.h>
#include "w4ais.h"



/* Malloc's a string; returns it.
*/

char *mystrdup(s)
    char *s;
{
    char *p;

    p = (char *) emalloc(strlen(s) + 1);
    strcpy(p, s);
    return p;
}

/* Makes sure you have enough memory to continue...
*/

void *emalloc(i)
    int i;
{
    void *p;

    if ((p = (void *) malloc(i)) == NULL)
        progerr("Ran out of memory.");
    return p;
}

/* How many times does the a character appear in a line?
*/

int numchar(line, c)
    char *line;
    char c;
{
    int i;

    for (i = 0; *line; line++)
        if (*line == c)
            i++;
    return i;
}
