#include <stdio.h>
#include <string.h>
#include "w4ais.h"


/* In a string, replaces all occurrences of "oldpiece" with "newpiece".
** Not sure if this is bulletproof yet.
*/

char *replace(string, oldpiece, newpiece)
    char *string;
    char *oldpiece;
    char *newpiece;
{
    int i, j, limit;
    char *c;
    char beforestring[MAXSTRLEN], afterstring[MAXSTRLEN];
    static char newstring[MAXSTRLEN];

    if ((c = (char *) strstr(string, oldpiece)) == NULL)
        return string;
    limit = c - string;

    for (i = 0; i < limit; i++)
        beforestring[i] = string[i];
    beforestring[i] = '\0';

    i += strlen(oldpiece);

    for (j = 0; string[i] != '\0'; i++)
        afterstring[j++] = string[i];
    afterstring[j] = '\0';

    sprintf(newstring, "%s%s%s", beforestring, newpiece, afterstring);

    while (strstr(newstring, oldpiece))
        strcpy(newstring, replace(newstring, oldpiece, newpiece));

    return newstring;
}

