
#include <stdio.h>
#include <string.h>
#include "w4ais.h"


char *ruleparse(line)
    char *line;
{
    char rule[MAXSTRLEN];
    static char tmpline[MAXSTRLEN], newtmpline[MAXSTRLEN];
    static char line1[MAXSTRLEN], line2[MAXSTRLEN];
    struct source *tmplist;

    tmplist = ruleslist;
    strcpy(tmpline, line);
    while(1) {
        strcpy(rule, getrule());
        if (rule[0] == '\0') {
            ruleslist = tmplist;
            return tmpline;
        }
        else {
            if (lstrstr(rule, "replace")) {
                strcpy(line1, getrule());
                strcpy(line2, getrule());
                strcpy(newtmpline, replace(tmpline, line1, line2));
            }
            else if (lstrstr(rule, "append"))
                sprintf(newtmpline, "%s%s", tmpline, getrule());
            else if (lstrstr(rule, "prepend"))
                sprintf(newtmpline, "%s%s", getrule(), tmpline);
            strcpy(tmpline, newtmpline);
        }
    }
}

/* Grabs the next rule from the list.
*/

char *getrule()
{
    static char rule[MAXSTRLEN];

    if (ruleslist == NULL)
        return "\0";
    strcpy(rule, ruleslist->line);
    ruleslist = ruleslist->next;

    return rule;
}
